<div class="component-correct-width">
  <div class="flex-container admin-home-header" fxLayout fxLayout.xs="column" fxLayoutWrap="wrap">
    <div fxFlex="50">
      <div fxLayout="column">
        <div fxFlex="50" class="bigger-font">
          Welcome Administrator!
        </div>
        <div fxFlex="50">
          Create or view users...
        </div>
      </div>
    </div>
    <div fxFlex="50" fxLayoutAlign="end center">
      <div fxLayout="column">
        <app-admin-nav-bar></app-admin-nav-bar>
      </div>
    </div>
  </div>

  <form novalidate [formGroup]="userGroup" autocomplete="off">
    <md-card class="admin-card">
      <md-card-content>

        <md-radio-group formControlName="role" name="userRole">
          <!-- Role -->
          <md-radio-button value="hungry" class="admin-checkbox">User is hungry</md-radio-button>
          <md-radio-button value="chef" class="admin-checkbox">User is a chef</md-radio-button>
          <md-radio-button value="admin" class="admin-checkbox">User is an administrator</md-radio-button>
        </md-radio-group>

        <div>
          <md-input-container class="admin-input">
            <!-- First name -->
            <input type="text" mdInput placeholder="First name" formControlName="firstName" name="firstName" />
            <md-error class="error" *ngIf="userGroup.get('firstName').touched && userGroup.get('firstName').hasError('required')">
              First Name is required
            </md-error>
            <md-error class="error" *ngIf="userGroup.get('firstName').touched && userGroup.get('firstName').hasError('minlength')">
              Minimum of 2 characters
            </md-error>
            <md-error class="error" *ngIf="userGroup.get('firstName').touched && userGroup.get('firstName').hasError('maxlength')">
              Maximum of 20 characters
            </md-error>
          </md-input-container>
          <md-input-container class="admin-input">
            <!-- Last name -->
            <input type="text" mdInput placeholder="Last name" formControlName="lastName" name="lastName" />
            <md-error class="error" *ngIf="userGroup.get('lastName').touched && userGroup.get('lastName').hasError('required')">
              Last Name is required
            </md-error>
            <md-error class="error" *ngIf="userGroup.get('lastName').touched && userGroup.get('lastName').hasError('minlength')">
              Minimum of 2 characters
            </md-error>
            <md-error class="error" *ngIf="userGroup.get('lastName').touched && userGroup.get('lastName').hasError('maxlength')">
              Maximum of 20 characters
            </md-error>
          </md-input-container>
          <md-input-container class="admin-input">
            <!-- Email -->
            <input type="text" mdInput placeholder="Email" formControlName="email" name="email" />
            <md-error class="error" *ngIf="userGroup.get('email').touched && userGroup.get('email').hasError('required')">
              Email is required
            </md-error>
            <md-error class="error" *ngIf="userGroup.get('email').touched && userGroup.get('email').hasError('email')">
              Invalid email
            </md-error>
            <md-error class="error" *ngIf="userGroup.get('email').touched && userGroup.get('email').hasError('maxlength')">
              Maximum of 20 characters
            </md-error>
          </md-input-container>
        </div>

        <div>
          <div class="flex-container admin-home-header" fxLayout fxLayout.xs="column" fxLayoutWrap="wrap">
            <div fxFlex="25">

              <md-input-container class="admin-input">
                <!-- Password -->
                <input type="password" mdInput placeholder="Password" formControlName="password" />
                <md-hint class="smaller-font">
                  Must be at least 6 characters
                </md-hint>
                <md-error *ngIf="userGroup.get('password').touched && userGroup.get('password').hasError('required')">
                  Password is required
                </md-error>
                <md-error *ngIf="userGroup.get('password').touched && userGroup.get('password').hasError('minlength')">
                  Minimum of 6 characters
                </md-error>
                <md-error *ngIf="userGroup.get('password').touched && userGroup.get('password').hasError('maxlength')">
                  Maximum of 20 characters
                </md-error>
              </md-input-container>

            </div>
            <div fxFlex="25">
              <md-input-container class="admin-input">
                <!-- Repeat Password -->
                <input type="password" mdInput placeholder="Confirm Password" formControlName="rePassword" />


                <md-error *ngIf="userGroup.get('rePassword').touched && userGroup.get('rePassword').hasError('required')">
                  Please repeat password
                </md-error>
                <md-error *ngIf="userGroup.get('rePassword').touched && userGroup.hasError('nomatch')">
                  Passwords must match
                </md-error>
                <md-error *ngIf="userGroup.get('rePassword').touched && userGroup.hasError('maxlength')">
                  Maximum of 20 characters
                </md-error>
              </md-input-container>
            </div>

            <div fxFlex="10" fxLayoutAlign="center center">
              <!-- Submit button -->
              <button md-raised-button color="accent" [disabled]="userGroup.invalid || createUserDisable" (click)="onSubmit(userGroup)">Create Account</button>
            </div>
            <div fxFlex="8" fxLayoutAlign="center center">
              <!-- Cancel button -->
              <button md-raised-button color="primary" (click)="populateForm()">Cancel</button>
            </div>

            <div fxFlex="7" fxLayoutAlign="center center" *ngIf="createUserDisable">
              <md-spinner class="spinner-small"></md-spinner>
            </div>
            <div fxFlex="5" fxLayoutAlign="center center" *ngIf="createUserDisable">
              Processing...
            </div>
          </div>
        </div>
        <div class="smaller-font flex-container" fxLayout fxLayout.xs="column" fxLayoutWrap="wrap">
          <div fxFlex="34">
            <div fxLayout="row" fxLayoutAlign="start start">

            </div>
          </div>
          <div fxFlex="40">
            <div fxLayout="row" fxLayoutAlign="end start">
              By clicking Create Account, I agree to the&nbsp;<a (click)="tos.getTerms(0)">Terms of Service</a>&nbsp;and&nbsp;
              <a (click)="tos.getTerms(1)">Privacy Policy</a>.
            </div>
          </div>
        </div>

      </md-card-content>
    </md-card>
  </form>

  <md-spinner *ngIf="!usersLoaded" class="big-spinner"></md-spinner>

  <div *ngIf="usersLoaded === true">
    <div class="bigger-font admin-home-heading">
      User List
    </div>

    <div class="flex-container admin-home-heading" fxLayout fxLayout.xs="column" fxLayoutWrap="wrap">
      <div fxFlex="10" fxLayoutAlign="start center">
        <md-select placeholder="Show" [(ngModel)]="selectedShow" name="show" (ngModelChange)="onOrderingChange($event)" class="admin-select-pagesize">
          <md-option *ngFor="let show of shows" [value]="show.value">
            {{show.viewValue}}
          </md-option>
        </md-select>
      </div>

      <div fxFlex="14" fxLayoutAlign="start center">
        <md-select placeholder="Order by" [(ngModel)]="selectedSort" name="sort" (ngModelChange)="onOrderingChange($event)" class="admin-select-sorttype">
          <md-option *ngFor="let sort of sorts" [value]="sort.value">
            {{sort.viewValue}}
          </md-option>
        </md-select>
      </div>

      <div fxFlex="4" fxLayoutAlign="center center">
        <button md-mini-fab mdTooltip="Sort in ascending order" [disabled]="orderingTypeDisable" (click)="setOrderingType('asc')"><md-icon>arrow_upward</md-icon></button>
      </div>
      <div fxFlex="3" fxLayoutAlign="center center">
        <button md-mini-fab mdTooltip="Sort in descending order" [disabled]="orderingTypeDisable" (click)="setOrderingType('desc')"><md-icon>arrow_downward</md-icon></button>
      </div>

      <div fxFlex="5" fxLayoutAlign="center center">
        <md-spinner class="spinner-small" *ngIf="orderingTypeDisable"></md-spinner>
      </div>
      <div fxFlex="8" fxLayoutAlign="center center">
        <span *ngIf="orderingTypeDisable">Processing...</span>
      </div>

      <div fxFlex="56" fxLayoutAlign="end start">
        <app-pagination [pageSize]="selectedShow" [currentPage]="currentPage" [totalItems]="numOfUsers" (changePageEvent)="changePageHandler($event)">
        </app-pagination>
      </div>
    </div>

    <div *ngFor="let user of allUsers.users">
      <app-user [inputUser]="user" (userDeleted)="getUsers()"></app-user>
    </div>

    <div class="flex-container" fxLayout fxLayout.xs="column" fxLayoutWrap="wrap">
      <div fxFlex="100" fxLayoutAlign="end center">
        <app-pagination [pageSize]="selectedShow" [currentPage]="currentPage" [totalItems]="numOfUsers" (changePageEvent)="changePageHandler($event)">
        </app-pagination>
      </div>
    </div>

  </div>
</div>
